// 
// Copyright (c) 2008 smdn <smdn@smdn.jp>
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

using System;
using System.Text;

using Smdn.Text.Encodings;

namespace Smdn.Formats.Mime {
  // TODO: change modifier to static internal
  public /*static internal*/ class Charsets {
    [Obsolete("deprecated, use System.Text.Encoding.ASCII instead", true)]
    public static Encoding ASCII {
      get { return Encoding.ASCII; }
    }

    [Obsolete("deprecated, use System.Text.Encoding.UTF7 instead", true)]
    public static Encoding UTF7 {
      get { return Encoding.UTF7; }
    }

    [Obsolete("deprecated, use System.Text.Encoding.UTF8Encoding(false, true) instead", true)]
    public static Encoding UTF8 {
      get { return UTF8NoBom; }
    }

    [Obsolete("deprecated, use System.Text.Encoding.GetEncoding(\"ISO-8859-1\") instead", true)]
    public static Encoding Latin1 {
      get { return ISO8859_1; }
    }

#if NETFRAMEWORK
    [Obsolete("deprecated, use System.Text.Encoding.GetEncoding(\"ISO-2022-JP\") instead", true)]
    public static Encoding JIS {
      get { return ISO2022JP; }
    }

    [Obsolete("deprecated, use System.Text.Encoding.GetEncoding(\"shift_jis\") instead", true)]
    public static Encoding ShiftJIS {
      get { return Shift_JIS; }
    }
#endif

    [Obsolete("deprecated, use Smdn.Text.Encodings.EncodingUtils.GetEncodingThrowException instead", true)]
    public static Encoding FromString(string name)
    {
      return FromString(name, null);
    }

    [Obsolete("deprecated, use Smdn.Text.Encodings.EncodingUtils.GetEncodingThrowException instead", true)]
    public static Encoding FromString(string name, EncodingSelectionCallback selectFallbackCharset)
    {
      return EncodingUtils.GetEncodingThrowException(name, selectFallbackCharset);
    }

    [Obsolete("deprecated, use System.Text.Encoding.BodyName instead", true)]
    public static string ToString(Encoding encoding)
    {
      if (encoding == null)
        throw new ArgumentNullException(nameof(encoding));

#if NETFRAMEWORK || NETSTANDARD2_0
      return encoding.BodyName;
#else
      return encoding.WebName;
#endif
    }

    internal static readonly Encoding ISO8859_1 = Encoding.GetEncoding("ISO-8859-1");
#if NETFRAMEWORK
    internal static readonly Encoding ISO2022JP = Encoding.GetEncoding("ISO-2022-JP");
    internal static readonly Encoding Shift_JIS  = Encoding.GetEncoding("shift_jis");
#endif
    internal static readonly Encoding UTF8NoBom = new UTF8Encoding(false, true);
  }
}
